#ifndef n_qtMovImageSource_H
#define n_qtMovImageSource_H

/*
 *
 * nucleo/image/source/qtMovImageSource.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/image/source/ImageSource.H>
#include <nucleo/core/URL.H>
#include <nucleo/core/TimeKeeper.H>

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>

namespace nucleo {

  class qtMovImageSource : public ImageSource {

  private:

    MovieController _thePlayer ;
    Movie _theMovie ;
    MovieDrawingCompleteUPP _proc ;
    Image::Encoding _qt_encoding ;

    bool _haveImage ;
    unsigned int _quality ;
    Image::Encoding _nucleo_encoding ;
    Image _img ;

    enum { BEZERK, INACTIVE, ACTIVE } _state ;

    TimeKeeper *_tk ;
    unsigned int _deltat ;

  protected:

    void react(Observable*) ;

    friend pascal OSErr DrawCompleteProc(Movie theMovie, long ptr) ;

  public:

    qtMovImageSource(Image::Encoding e, const URL &u) ;
    ~qtMovImageSource() ;

    bool start(void) ;
    bool getNextImage(Image *) ;
    bool isActive(void)  { return (_state==ACTIVE) ; }
    bool stop(void) ;

  } ;

}

#endif
