#ifndef n_qtSgImageSource_H
#define n_qtSgImageSource_H

/*
 *
 * nucleo/image/source/qtSgImageSource.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/image/source/ImageSource.H>
#include <nucleo/core/URL.H>
#include <nucleo/core/TimeKeeper.H>

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>

namespace nucleo {

  class qtSgImageSource : public ImageSource {

  private:

    SeqGrabComponent _sg ;
    GWorldPtr     _pGWorld ;
    Rect          _bounds ;
    ImageSequence _decomSeq ;
    Image::Encoding _qt_encoding ;

    bool _haveImage ;
    unsigned int _quality ;
    Image::Encoding _nucleo_encoding ;
    Image _img ;

    TimeKeeper *_tk ;

    enum { BEZERK, READY, ACTIVE } _state ;

    friend pascal OSErr sgDataProc(SGChannel c, Ptr p, long len, long *offset,
							long chRefCon, TimeValue time, short writeType, long refCon);

  protected:

    void react(Observable*) ;

  public:

    qtSgImageSource(Image::Encoding e, const URL &u) ;
    ~qtSgImageSource() ;

    bool start(void) ;
    bool getNextImage(Image *) ;
    bool isActive(void)  { return (_state==ACTIVE) ; }
    bool stop(void) ;

  } ;

}

#endif
