/*
 *
 * nucleo/network/NetworkUtils.cxx --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/config.H>

#include <nucleo/network/NetworkUtils.H>

#include <arpa/inet.h>
#include <netdb.h>

#include <string>
#include <stdexcept>

namespace nucleo {

  struct in_addr*
  resolveAddress(const char *address) {
    struct hostent *host ;
    static struct in_addr saddr ;

    // First try it as aaa.bbb.ccc.ddd
    saddr.s_addr = inet_addr(address) ;
    if (saddr.s_addr != INADDR_NONE) return &saddr ;

    host = gethostbyname(address) ;
    if (host!=NULL) {
	 /*
	   unsigned char *v = (unsigned char *)((struct in_addr *) *host->h_addr_list) ;
	   std::cerr << "atoaddr (2) : " << address << " --> " << (int)v[0] << "." << (int)v[1] << "." << (int)v[2] << "." << (int)v[3] << std::endl ;
	 */
	 return (struct in_addr *) *host->h_addr_list ;
    }

    throw std::runtime_error(std::string("resolveAddress: Unable to guess IP address from ")+address) ;
  }

}
