/*
 *
 * nucleo/network/tcp/TcpUtils.cxx --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/config.H>

#include <nucleo/network/tcp/TcpUtils.H>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#include <signal.h>

namespace nucleo {

  void
  setDefaultTcpSocketOptions(int sock, bool server) {
    int one=1, five=5 ;
    setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (char *)&one, sizeof(int)) ;
#ifdef TCP_FASTACK
    setsockopt(sock, IPPROTO_TCP, TCP_FASTACK, (char *)&one, sizeof(int)) ;
#endif
#ifdef SO_RCVTIMEO
    setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (char *)&five, sizeof(int)) ;
#endif
#ifdef SO_SNDTIMEO
    setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, (char *)&five, sizeof(int)) ;
#endif
    if (server) {
#ifdef SO_REUSEPORT
	 setsockopt(sock, SOL_SOCKET, SO_REUSEPORT, (char *)&one, sizeof(int)) ;
#endif
	 setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *)&one, sizeof(int)) ;
    }
#ifdef SO_NOSIGPIPE
    setsockopt(sock, SOL_SOCKET, SO_NOSIGPIPE, (char *)&one, sizeof(int)) ;
#endif
    
    signal(SIGPIPE, SIG_IGN) ;
  }
  
}
