#ifndef n_ffmpegImageSink_H_
#define n_ffmpegImageSink_H_

/*
 *
 * nucleo/plugins/ffmpeg/ffmpegImageSink.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/image/sink/ImageSink.H>
#include <nucleo/core/URL.H>

#include <avformat.h>

using namespace nucleo ;

class ffmpegImageSink : public ImageSink {

private:

  std::string _filename ;
  int _fd ;
  bool _ownfd ;

  bool _active ;

  std::string _format ;
  int _framerate,
    _bitrate /* kbits/sec */,
    _gopsize /* 0 is intra-only */,
    _qscale ;

  AVOutputFormat *_avf ;
  AVStream _st ;
  AVFormatContext _avfc ;
  unsigned char _inbuffer[32768] ;
  unsigned char _outbuffer[131072] ;

  bool init(Image *img) ;

public:

  ffmpegImageSink(int fd, const char* format,
			   int framerate, int bitrate, int gopsize, int qscale) ;
  ffmpegImageSink(const URL &url) ;

  ~ffmpegImageSink() { stop() ; }

  bool start(void) ;
  bool handle(Image *img) ;
  bool isActive(void) { return _active ; }
  bool stop(void) ;

} ;

#endif
