#ifndef n_howlKeeper_H
#define n_howlKeeper_H

/*
 *
 * nucleo/plugins/howl/howlKeeper.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/TimeKeeper.H>
#include <rendezvous/rendezvous.h>

#include <stdexcept>

namespace nucleo {

  class howlKeeper : public ReactiveObject {

  protected:

    sw_rendezvous session ;
    sw_salt salt ;
    TimeKeeper *_tk ;

    static howlKeeper *keeper ;
    static int nbClients ;

    howlKeeper(void) ;
    void react(Observable*) ;
    ~howlKeeper(void) ;

  public:

    static void attach(void) ;
    static sw_rendezvous getSession(void) ;
    static void detach(void) ;

  } ;

}

#endif
