#ifndef n_howlServiceFinder_H
#define n_howlServiceFinder_H

/*
 *
 * nucleo/plugins/howl/howlServiceFinder.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/network/rdv/Service.H>
#include <nucleo/network/rdv/ServiceFinder.H>

#include <nucleo/plugins/howl/howlKeeper.H>

#include <list>

namespace nucleo {

  class howlServiceFinder : public ServiceFinder {

  private:

    sw_result result ;
    sw_rendezvous_browse_id id ;
    std::list<sw_rendezvous_resolve_id> rids ;

    static sw_result
    sfResolver(sw_rendezvous_resolve_handler instance,
			sw_rendezvous rendezvous,
			sw_rendezvous_resolve_id id,
			sw_const_string name,
			sw_const_string type,
			sw_const_string domain,
			sw_ipv4_address address,
			sw_port port,
			sw_const_string text_record_string,
			sw_octets text_record,
			sw_ulong text_record_len,
			sw_opaque extra) ; 

    static sw_result
    sfBrowseReply(sw_rendezvous_browse_handler	instance,
			   sw_rendezvous rendezvous,
			   sw_rendezvous_browse_id id,
			   sw_rendezvous_browse_status status,
			   sw_const_string name,
			   sw_const_string type,
			   sw_const_string domain,
			   sw_opaque extra) ;   

  public:

    howlServiceFinder(const char *type, EventQueue *queue, const char *domain=0) ;
    ~howlServiceFinder(void) ;

  } ;

}

#endif
